;*******************************************************
HLinea	MACRO			;Horizontal line drawing routine
;*************
;       bra     EndHLine\1
fglib@012\1:
	dc.w	$4E71
	dc.w	$4E71
	movem.l	a0/a1,-(a7)
	move.w	d0,-(a7)

;	move.b	d5,-(a7)		
	move.b	d5,d4
	move.b	Offset,d0 
	cmpa.l	a0,a1		;a0<a1 ?
	blt	a1smallest\1	;a1<a0
	beq	EndHLine_X\1	;a0=a1

	subq.b	#$1,d4		;here a0<a1
	not.b	d4		;e.g; before: d4=%00000100
				; after: d4=%11111100

        movea.l  a1,a4           ;
        adda.l  #$F00,a4        ;
	
fglib@00A\1                  
	nop
	or.b	d4,(a1)		;Apply the mask (or, or/eor, and, eor, none...)
fglib@00A\2
        nop                     ;
        or.b    d4,(a4)         ;

	subq	#1,a1
	addq	#$1,a0		;a0<a1, we will start drawing from a1 to a0+1,
				;and we will finish the last byte of a0 filling with bits.
HLoop1_\1
	cmpa.l	a0,a1		; Same byte ?
	blt	EndHLine_1Before\1	; yes, finish the byte at EndHLine_1Before\1

        movea.l  a1,a4           ;
        adda.l  #$F00,a4        ;

fglib@010\1
	dc.w	$50D1		;mask of the byte st.b	(a1)
fglib@010\2
        dc.w    $50D4           ;

	subq	#1,a1		; 1 byte done, loop
	bra	HLoop1_\1

EndHLine_1Before\1:		; here a0=a1

	move.b	Offset,d0	; e.g; before: d0=%00000100
	lsl.b	#$1,d0	
	subq.b	#$1,d0		; after: d0=%00000111

        movea.l  a1,a4           ;
        adda.l  #$F00,a4        ;

fglib@00D\1
	nop			;apply masks
	or.b	d0,(a1)		;
fglib@00D\2
        nop                     ; apply masks on 2 plane
        or.b    d0,(a4)         ;

;	move.b	(a7)+,d5
	move.w	(a7)+,d0	
	movem.l	(a7)+,a0/a1		
	bra	EndHLine\1	;END

;*************
EndHLine_1\1:			; here a0=a1 BUT this, since the begining.
	subq.b	#$1,d4		;e.g; before: d4=%00000100
	not.b	d4		; after: d4=%11111100

	lsl.b	#$1,d0		;e.g; before: d0=%00010000 !!
	subq.b	#$1,d0		; after: d0=%00011111
	and.b	d4,d0		;e.g; d0=%00011100

        movea.l  a1,a4           ;
        adda.l  #$F00,a4        ;

fglib@00E\1
	nop			;apply masks
	or.b	d0,(a1)		;
fglib@00E\2
        nop                     ; apply masks on 2 plane
        or.b    d0,(a4)         ;

;	move.b	(a7)+,d5
	move.w	(a7)+,d0
	movem.l	(a7)+,a0/a1		
	bra	EndHLine\1	;END

;*************
EndHLine_X\1:			; "Dispatcheur"
	cmp.b	d4,d0		
	bcc	EndHLine_1\1
	bra	EndHLine_2\1
;*************

;*************
a1smallest\1:				;a1<a0
	move.b	Offset,d0
	subq.b	#$1,d0		
	not.b	d0

        movea.l  a0,a4           ;
        adda.l  #$F00,a4        ;

fglib@00B\1
	nop	
	or.b	d0,(a0)	
fglib@00B\2
        nop                     ;
        or.b    d0,(a4)         ;

	subq	#$1,a0		
	addq	#$1,a1
	
HLoop2_\1:		
	cmpa.l	a0,a1			
	bhi	EndHLine_2Before\1

        movea.l  a0,a4           ;
        adda.l  #$F00,a4        ;

fglib@011\1
	dc.w	$50D0			;st.b	(a0)
fglib@011\2
        dc.w    $50D4                   ;
	subq	#$1,a0		
	bra	HLoop2_\1


EndHLine_2Before\1:
	lsl.b	#$1,d4		;!!
	subq.b	#$1,d4

        movea.l  a0,a4           ;
        adda.l  #$F00,a4        ;

fglib@00F\1
	nop
	or.b	d4,(a0)
fglib@00F\2
        nop                     ;
        or.b    d4,(a4)         ;

;	move.b	(a7)+,d5
	move.w	(a7)+,d0
	movem.l	(a7)+,a0/a1 
	bra	EndHLine\1	

EndHLine_2\1:	
	subq.b	#$1,d0		
	not.b	d0
	lsl.b	#$1,d4		;!!
	subq.b	#$1,d4		
	and.b	d0,d4

        movea.l  a1,a4           ;
        adda.l  #$F00,a4        ;

fglib@00C\1
	nop	
	or.b	d4,(a1)
fglib@00C\2
        nop                     ;
        or.b    d4,(a4)         ;

;	move.b	(a7)+,d5	
	move.w	(a7)+,d0
	movem.l	(a7)+,a0/a1
;	bra	EndHLine\1	

EndHLine\1:
fglib@013\1:
	ENDM		
;*******************************************************
